# class Promise<T>

#### package js

Available on HTML5

### Constructor

###

`new (init:T ‑> Void ‑> Dynamic ‑> Void ‑> Void)`

Throws:

`null` | DOMError

### Methods

###

`catchError<TOut> (rejectCallback:EitherType<Dynamic ‑> Void, PromiseCallback<Dynamic, TOut>>):Promise<TOut>`

###

`then<TOut> (fulfillCallback:Null<PromiseCallback<T, TOut>>, ?rejectCallback:EitherType<Dynamic ‑> Void, PromiseCallback<Dynamic, TOut>>):Promise<TOut>`

### Static methods

###

`staticall (iterable:Array<Dynamic>):Promise<Array<Dynamic>>`

###

`staticrace (iterable:Array<Dynamic>):Promise<Dynamic>`

###

`staticreject<T> (?value:Dynamic):Promise<T>`

###

`staticresolve<T> (?value:T):Promise<T>`

`staticresolve<T> (promise:Promise<T>):Promise<T>`

`staticresolve<T> (thenable:Thenable<T>):Promise<T>`